# Safehouse for H3MP (Sponsored)
### [>>[TUTORIAL_VIDEO: t-b-a]]

A standalone, independent version of [Safehouse Progression](https://h3vr.thunderstore.io/package/NGA/SafehouseProgression/) made-for [H3VR](https://h3vr.thunderstore.io/package/VIP/H3MP/) compatibility.  
* New buttons with multiplayer-friendly functionalities
* Many more options for saving quickbelts and scenes
* Audible "error boop" sounds when saving quickbelt or scene fails
* Independent saving from original Safehouse Progression mod

## Buttons
**Save-Loadout**  
 - Saves your current quickbelt loadout to a Vault file.
 - (Configurable) Cleans up all items you're currently wearing.

**Spawn-Loadout**  
- Spawns your previously-saved loadout.
- Clears you current equipped items if nothing was saved.
- (Configurable) After spawning, it will delete the saved loadout file to avoid duplication abuse.

**Enter-Safehouse (HOST ONLY)**  
- Only the H3MP host should click on this button, otherwise there may be weird desyncs.
- Spawns you in your safehouse (configurable) map.
- Automatically loads your last saved safehouse scene file.

**Save-Safehouse**
- Saves your current safehouse scene to a vault file.
- (Configurable) Has a 1/(denominator) chance to create a backup vault file of the scene with current date & time. Default 50%.

## Config Variables
* House:
  * **SceneID INDEX**: Swap between 3 safehouse scene IDs you specified below.
  * **Safehouse Scene ID**: 1
  * **Safehouse Scene ID**: 2
  * **Safehouse Scene ID**: 3
* Saving:
  * **Delete Saved Loadout after Spawned**: Whether the loadout you saved will be deleted after you press the Spawn-Loadout button.
  * **Clear Quickbelt after Save-Loadout**: Will clear everything you're wearing from your quickbelt after clicking Save-Loadout.
  * **Chance to perform a backup (denominator)**: Creates a backup with a 1 in (denominator) chance% every time scene is saved. Default denominator of 2 means 1/2 or 50% chance.

**Vanilla Scene IDs**:  
```
"Grillhouse_2Story", "IndoorRange",
"GP_Hangar", "SniperRange", "ArizonaTargets", 
"WarehouseRange_Rebuilt", "Friendly45_New", "ArizonaTargets_Night", 
"BreachAndClear_TestScene1", "ProvingGround", "ObstacleCourseScene1",
"NewSnowGlobe", "Wurstwurld1", "MF2_MainScene", "Boomskee",
"Testing3_LaserSword", "MeatGrinder","OmnisequencerTesting3",
"WinterWasteland", "Cappocolosseum", "SamplerPlatter  
```  
**Modded Scene IDs**:
After loading into a modded map, search the logs for a "SCENE ID: XXX". Copy whatever XXX is Exactly, including capital letters, spaces, and special characters.

## Automatic Backup of Safehouse
There's a (Configurable) 50% chance that after you press "Save-Safehouse" a back-up scene save file of your safehouse will be created. You can find it in the 'Save/Load Scene' wrist menus with the format `SCENENAME_BACKUP_DATE&TIME`.  
You will find these in your `Wrist Menu` > `Load Scene` > `My Saved Scenes`

## Known Bugs
* You may lose *specific* items in your loadout or safehouse when extracting or deploying. This is expected, reach out to the authors of the missing mods to ask for a "Vault Saving Fix".
* Some items mounted on rails of missing items may cause game-breaking scenarios where scene/loadout won't finish saving :(
* Go report new ones here: [>>[Feedback form]<<](https://forms.gle/TBEe2btHePCsGp557)

## Planned Features
- [✓] Release demo for H3MP testing
- [✓] Initial H3MP testing successful
- [✓] Polishing rounds
- [_] Port new configurable items to original Safehouse Progression

## Versions
### 1.0.0
* Public release.
### 0.1.0
* New: Ability to quickly swap between 3 safehouse scene ids.
* Bug fix: After booting up the game, you can now load into a modded map safehouse without the game crashing.
### 0.0.3
* Replaces "Confirm ???" with corresponding "Button Name ???" for QOL.
### 0.0.2
* Adds new 'delete quickbelt on successful loadout save' configurable
### 0.0.1 (ALPHA!)
* Adds new buttons for refactored functionalities.
* Adds "error" noise whenever a loadout/scene can't be properly saved so user can remove offending items.
* Tested locally without H3MP.